﻿package com.microsoft {
	
	import flash.display.Sprite;
	import flash.events.Event;
	import com.remix.events.ArrayEvent;
	import flash.events.MouseEvent;
	import flash.net.SharedObject;
	import flash.filesystem.File;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.utils.setTimeout;
	import com.greensock.layout.AutoFitArea;
	import com.greensock.layout.ScaleMode;
	import com.greensock.TweenLite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.display.Bitmap;
	import flash.events.IOErrorEvent;
	
	public class BigScreen extends Sprite{
		
		private var db:LocalDatabase = new LocalDatabase();
		private var lc:LanConnection = new LanConnection();
		
		private var so:SharedObject;
		
		private var snapsFolder:File;
		private var loaders:Array = new Array();
		private var areas:Array = new Array();
		
		private var timer:Timer = new Timer(120000);
		
		public function BigScreen() {
			// constructor code
			
			this.addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event):void{
			this.removeEventListener(Event.ADDED_TO_STAGE, init);
			lc.addEventListener("messageReceived", receivedVote);
			
			stage.displayState = "fullScreen";
			
			so = SharedObject.getLocal("remix");
			if(so.data["directory"]){
				snapsFolder = new File(so.data["directory"]);
				folder_mc._txt.text = snapsFolder.nativePath;
				folder_mc.visible = false;
			}else{
				snapsFolder = new File();
				
			}
			
			snapsFolder.addEventListener(Event.SELECT, dirSelected); 
			folder_mc.change_mc.addEventListener(MouseEvent.CLICK, changeFolder);
			folder_mc.close_mc.addEventListener(MouseEvent.CLICK, function():void{folder_mc.visible = false;});
			logo_mc.addEventListener(MouseEvent.CLICK, function():void{folder_mc.visible = true;});
			
			//set up loaders
			for(var i:int = 0; i < 11; i++){
				var l:Loader = new Loader();
				l.name = i.toString();
				trace(i);
				pics_mc["h"+i].addChild(l);
				loaders.push(l);
				
				l.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioError);
				l.contentLoaderInfo.addEventListener(Event.COMPLETE, loadedPic);
				
				pics_mc.whites_mc["p"+i].alpha = 0;
				
				pics_mc["h"+i].mask = pics_mc["p"+i];
				var area:AutoFitArea = new AutoFitArea(pics_mc["h"+i], 0, 0, pics_mc["p"+i].width, pics_mc["p"+i].height);
				areas.push(area);
			}
			updateSnaps();
			timer.addEventListener(TimerEvent.TIMER, updateTimer);
			timer.start();
			
			full_mc.addEventListener(MouseEvent.CLICK, toggleFull);
		}
		
		private function ioError(e:IOErrorEvent):void{
			//trace(e);
		}
		
		private function toggleFull(e:MouseEvent):void{
			trace(stage.displayState);
			if(stage.displayState == "fullScreen"){
				stage.displayState = "normal";
			}else{
				stage.displayState = "fullScreen";
			}
		}
		
		private function updateTimer(e:TimerEvent):void{
			updateSnaps();
		}
		
		private function loadedPic(e:Event):void{
			var num:int = int(e.target.loader.name);
			areas[num].attach(loaders[num], {scaleMode:ScaleMode.PROPORTIONAL_OUTSIDE});			
			
			Bitmap(loaders[num].content).smoothing = true;
			
			TweenLite.to(pics_mc.whites_mc["p"+num], 1, {alpha:0});
		}
		
		private function changeFolder(e:MouseEvent):void{
			
			snapsFolder.browseForDirectory("Select a directory"); 
			updateSnaps();
		}
		
		private function dirSelected(e:Event):void { 
			trace(snapsFolder.nativePath); 
			so.data["directory"] = folder_mc._txt.text = snapsFolder.nativePath;
		}
		
		private function receivedVote(e:ArrayEvent):void{
			trace(e.list[0].filename);
			db.submitVote(e.list[0].filename);
			
			//db.getTop20();
			//updateSnaps();
		}
		
		private function updateSnaps():void{
			var snaps:Array = db.getTop20();
			if(snaps){
				for(var i:int = 0; i < snaps.length; i++){
					//trace(snapsFolder.nativePath+"/"+snaps[i].filename);
					
					//loaders[i].load(new URLRequest(snapsFolder.url+"/"+snaps[i].filename));
					//loadSnap(i, snapsFolder.url+"/"+snaps[i].filename);
					setTimeout(loadSnap, Math.random()*10000, i, snapsFolder.url+"/"+snaps[i].filename);
				}
			}
		}
		
		private function loadSnap(i:int, url:String):void{
			trace("load");
			pics_mc.whites_mc["p"+i].alpha = 1;
			loaders[i].load(new URLRequest(url));
		}

	}
	
}
