﻿package com.microsoft {
	
	import flash.data.SQLConnection;
	import flash.filesystem.File;
	import flash.data.SQLStatement;
	import flash.errors.SQLError;
	import flash.events.EventDispatcher;
	
	public class LocalDatabase extends EventDispatcher{
		
		private var conn:SQLConnection = new SQLConnection(); 
		private var dbFile:File = File.applicationStorageDirectory.resolvePath("votes.db");
		
		public function LocalDatabase() {
			// constructor code
			initSQLdbase();
			//submitVote("pablo2.jpg");
			//getTop20();
			//deleteAllRows();
			trace("hi");
		}
		
		public function submitVote(filename:String):void{
			
			var checkStatement:SQLStatement = new SQLStatement();
			checkStatement.sqlConnection = conn;
			checkStatement.text = "SELECT id, filename, count FROM votes WHERE filename='"+filename+"'";
			try{
				checkStatement.execute();
				var result:Array  = checkStatement.getResult().data;
				//trace("result>",result[0].count);
				if(result){
					addVote(result[0].id);
				}else{
					addNewFile(filename);
				}
				
			} catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
		}
		
		private function addNewFile(filename:String):void{
			
			var insertData:SQLStatement = new SQLStatement();
			insertData.sqlConnection = conn;
			insertData.text = "INSERT INTO votes (filename, count) VALUES ('"+filename+"', 1)";
			
			try { 
				insertData.execute();
				var result:int = insertData.getResult().lastInsertRowID;
				trace(result);
			}catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
		}
		
		private function addVote(id:int):void{
			var updateStatement:SQLStatement = new SQLStatement();
			updateStatement.sqlConnection = conn;
			updateStatement.text = "UPDATE votes SET count = count+1 WHERE id="+id;
			
			try{
				updateStatement.execute();
			} catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
		}
		
		
		public function getTop20():Array{
			var checkStatement:SQLStatement = new SQLStatement();
			checkStatement.sqlConnection = conn;
			checkStatement.text = "SELECT * FROM votes ORDER BY count DESC LIMIT 10";
			
			var result:Array;
			
			try{
				checkStatement.execute();
				result = checkStatement.getResult().data;
				
			} catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
			return result;
		}
		
		private function deleteAllRows():void{
			
			trace("try delete");
			var checkStatement:SQLStatement = new SQLStatement();
			checkStatement.sqlConnection = conn;
			checkStatement.text = "DELETE FROM votes";
			try{
				checkStatement.execute();
				trace("All rows deleted");
			} catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
		}
		
		private function initSQLdbase():void{
			try{ 
				conn.open(dbFile); 
				trace("the database was created successfully"); 
				var createStmt:SQLStatement = new SQLStatement(); 
				createStmt.sqlConnection = conn; 
					 
				var sql:String =  
					"CREATE TABLE IF NOT EXISTS votes (" +  
					"    id INTEGER PRIMARY KEY AUTOINCREMENT, " +  
					"    filename TEXT, " +  
					"    count INTEGER)"; 
				createStmt.text = sql; 
					 
				try 
				{ 
					createStmt.execute(); 
					trace("Table created"); 
				} 
				catch (error:SQLError) 
				{ 
					trace("Error message:", error.message); 
					trace("Details:", error.details); 
				} 
				
			} catch (error:SQLError) { 
				trace("Error message:", error.message); 
				trace("Details:", error.details); 
			}
		}
	}
}
