﻿package com.outset
{

	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.net.Socket;

	import com.outset.events.SocketEvent;
	import com.greensock.TweenLite;

	public class SerialPort extends EventDispatcher
	{

		private var _host:String;
		private var _socket:Socket;

		private var values:Array = new Array  ;
		private var buffer:String;
		private var lineBefore:String;
		private var count:int = 0;

		private var sensArr:Array;
		private var arry:Array;
		private var stringArr:Array;
		private var str:String;
		private var len:Number;
		private var bufferStarted:Boolean = false;
		private var rfid:String = "";

		public static const ON_CONNECT:String = 'onConnect';
		public static const ON_CLOSE:String = 'onClose';

		public function SerialPort(host:String=null,port:int=0)
		{
			super();

			_socket = new Socket();
			_socket.addEventListener(Event.CLOSE,onClose);
			_socket.addEventListener(Event.CONNECT,onConnect);
			_socket.addEventListener(IOErrorEvent.IO_ERROR,onIOErrorEvent);
			_socket.addEventListener(SecurityErrorEvent.SECURITY_ERROR,onSecurityError);

			_socket.addEventListener(ProgressEvent.SOCKET_DATA,onSocketData);
			//_socket.addEventListener(Event.COMPLETE, onSocketData);

		}


		public function get connected():Boolean
		{
			return _socket.connected;
		}

		public function close():void
		{
			_socket.close();

		}

		public function connect(host:String=null,port:int=0):void
		{
			_socket.connect(host,port);
			//trace("connecting");
		}

		public function send(value:String):void
		{
			if(this.connected){
				_socket.writeUTFBytes(value);
				_socket.flush();
			}
		}


		private function onClose(event:Event):void
		{
			//trace("onClose");

			// try to keep the connection alive

			dispatchEvent(new SocketEvent(SocketEvent.ON_CLOSE));

			//dispatchEvent( event );
		}

		private function onConnect(event:Event):void
		{
			//trace("onConnect");

			dispatchEvent(new SocketEvent(SocketEvent.ON_CONNECT));

			//dispatchEvent( event );
		}

		private function onIOErrorEvent(event:IOErrorEvent):void
		{
			trace("onIOErrorEvent");
			dispatchEvent(event);
		}

		private function onSecurityError(event:SecurityErrorEvent):void
		{
			trace("onSecurityError");
			dispatchEvent(event);
		}

		private function onSocketData(event:ProgressEvent):void
		{
			trace("onSocketData", _socket.readUTFBytes( _socket.bytesAvailable ));
			//*
			if (bufferStarted){

				rfid +=  _socket.readUTFBytes(_socket.bytesAvailable);

				if (rfid.length == 13){
					//trace("kill");
					TweenLite.killDelayedCallsTo(timesUp);
					timesUp();
				}

			}else{
				bufferStarted = true;
				rfid = "";
				TweenLite.delayedCall(0.5,timesUp);
				rfid = _socket.readUTFBytes(_socket.bytesAvailable);
			}
			//*/
		}

		private function timesUp():void
		{
			bufferStarted = false;
			rfid = rfid.substr(1,12);
			//trace("rfid:",rfid);
			if (rfid.length == 12)
			{
				dispatchEvent(new DataEvent(DataEvent.DATA,false,false,rfid));
			}
			else
			{
				trace("Scan again!");
			}
		}

	}

}