﻿package com.remix {
	
	import flash.events.EventDispatcher;
	import flash.net.NetConnection;
	import flash.net.NetGroup;
	import flash.events.NetStatusEvent;
	import flash.events.Event;
	import com.remix.events.ArrayEvent;
	import flash.net.GroupSpecifier;
	
	public class LanConnection extends EventDispatcher{
		
		private var nc:NetConnection;
		private var group:NetGroup;
		
		private var sequence:int = 0;
		
		private var connected:Boolean = false;
		public var userName:String = "";
		
		public function LanConnection() {
			// constructor code
			connect();
		}
		
		private function connect():void{
			nc = new NetConnection();
			nc.addEventListener(NetStatusEvent.NET_STATUS, netStatus);
			nc.connect("rtmfp:");
		}
		
		private function netStatus(e:NetStatusEvent):void{

			switch (e.info.code)
			{
				case "NetConnection.Connect.Success" :
					setupGroup();
					trace("connected nc");
					break;

				case "NetGroup.Connect.Success" :
					trace("connected ng");
					connected = true;
					dispatchEvent(new Event("connected"));
					//sendMessage({filename:"pablo.jpg"});
					break;

				case "NetGroup.Posting.Notify" :
					trace("recieved");
					dispatchEvent(new ArrayEvent("messageReceived", [e.info.message]));
					break;
			}
		}

		private function setupGroup():void{
			
			var groupspec:GroupSpecifier = new GroupSpecifier("remix/session");
			groupspec.postingEnabled = true;
			groupspec.ipMulticastMemberUpdatesEnabled = true;
			groupspec.addIPMulticastAddress("225.225.0.1:30303");

			group = new NetGroup(nc, groupspec.groupspecWithAuthorizations());
			group.addEventListener(NetStatusEvent.NET_STATUS,netStatus);
			
		}
		
		public function sendMessage(message:Object):void{
			message.time = new Date().time;
			if(connected){
				trace("send",message.filename);
				group.post(message);
			}
			
		}

	}
	
}
