﻿package com.remix
{
	import flash.display.DisplayObject;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import com.greensock.TweenLite;
	
	/**
	* ...
	* @author DefaultUser (Tools -> Custom Arguments...)
	*/
	public class Scroller extends Sprite 
	{
		private var scrollBar:Sprite = new Sprite();
		private var scrollLine:Shape = new Shape();
		private var scrubShape:Shape = new Shape();
		private var scrubber:Sprite = new Sprite();
		
		public var md:Boolean = false;
		
		public var target:DisplayObject;
		public var __height:int = 0;
		public var yPos:int = 0;
		private var n:int = 2;
		
		public function Scroller(target:DisplayObject):void {
			this.target = target;
			this.yPos = yPos;
			scrollBar.addChild(scrollLine);
			scrubber.addChild(scrubShape);
			scrollBar.addChild(scrubber);
			this.addChild(scrollBar);
			
			scrubber.buttonMode = true;
			
			addEventListener(Event.ENTER_FRAME, update);
			scrubber.addEventListener(MouseEvent.MOUSE_DOWN, function():void
			{md = true; n = scrubber.mouseY; } );
			
			addEventListener(Event.ADDED_TO_STAGE, added);
			
			target.addEventListener(MouseEvent.MOUSE_WHEEL, wheeler);
		}
		
		private function wheeler(e:MouseEvent):void {
			var to:int = scrubber.y - e.delta;
			
			var scrollPercent:Number = to / __height;
			scrollBar.y = scrollPercent;
			
			TweenLite.to(target, 0.5, { y: -(scrollPercent * target.height) + yPos} );
			
			scrubber.y = to; //+ this.y;// ;
			if (scrubber.y >= __height - scrubber.height) {
				scrubber.y = __height - scrubber.height;
			}else if (scrubber.y <= 0) {
				scrubber.y = 0;
			}
		}
		
		private function added(e:Event):void {
			removeEventListener(Event.ADDED_TO_STAGE, added);
			stage.addEventListener(MouseEvent.MOUSE_UP, function():void
			{md = false; } );
		}
		//newHeight is content height
		//
		public function resize(newHeight:int, new_h:int):void {
			__height = new_h;
			
			//trace(__height,newHeight);
			TweenLite.to(scrollBar, 0.25, {onComplete:reDraw } );
			//this.alpha = 0;
			function reDraw():void {
				scrubber.graphics.clear();
				scrubShape.graphics.clear();
				scrollLine.graphics.clear();
				
				if (__height <= newHeight) {
					
					scrollLine.graphics.moveTo(0, 0);
					scrollLine.graphics.lineStyle(4, 0xffffff, 0.2, false, "normal", "none");
					scrollLine.graphics.lineTo(0, __height-4);
					
					scrubShape.graphics.moveTo(0, 0);
					scrubShape.graphics.lineStyle(25, 0xff0000, 1, false, "normal", "none");
					scrubShape.graphics.lineTo(0, __height * (__height / newHeight));
					
					
					scrubber.graphics.beginFill(0xff0000, 0);
					scrubber.graphics.drawRect( -10, 0, 20, __height * __height / newHeight);
					scrubber.graphics.endFill();
				
					scrubber.y = 0;
				}
				//TweenLite.to(this, 0.5,{alpha:1});
				TweenLite.to(target, 0.5, { y:yPos} );
			}
		}
		
		private function update(e:Event):void{
			//trace(this.md);
			if (this.md)
			{
				var scrollPercent:Number = scrubber.y / __height;
				scrollBar.y = scrollPercent; //+ yPos/2;
				
				//trace("MD",-1*-15, scrubber.y, __height, scrollPercent);
				
				TweenLite.to(target, 0.5, { y: -(scrollPercent * target.height) + yPos } );
				
				scrubber.y = this.mouseY - n; //+ this.y;// ;
				//TweenLite.to(scrubber, 0.25, { y:this.mouseY - n } );
				if (scrubber.y >= __height - scrubber.height) {
					scrubber.y = __height - scrubber.height;
					//TweenLite.to(scrubber, 0.5, { y:__height - scrubber.height } );
				}else if (scrubber.y <= 0) {
					scrubber.y = 0;
					//TweenLite.to(scrubber, 0.5, { y:0 } );
				}
				
			}
		}
	}
	
}